<template>
  <div class="expand-language">
    <el-collapse v-model="activeNames" class="w-full" :accordion="true">
      <el-collapse-item name="language">
        <template #title>
          <div class="w-full flex justify-between items-center">
            <div class="flex items-center justify-between cursor-pointer gap-2">
              <div :class="isMobile ? 'icon-lang-mobile' : 'icon-lang'">
                <img
                  :src="
                    getAssetImage(
                      `assets/materials/languageIcon/${defaultLanguage}.svg`
                    )
                  "
                />
              </div>
              <div class="flex items-center gap-[2px]">
                <span class="langauge-label">
                  {{ defaultLanguageForDisplay }}
                </span>
              </div>
            </div>
            <svg-icon svg-name="arrow-fill-down" class="w-5 h-5 header-icon" />
          </div>
        </template>
        <div>
          <div
            class="flex items-center cursor-pointer gap-2 active language-option"
          >
            <div class="flex items-center">
              <div class="icon-lang"></div>
              <img
                :class="isMobile ? 'flag-img-mobile' : 'flag-img'"
                :src="
                  getAssetImage(
                    `assets/materials/languageIcon/${defaultLanguage}.svg`
                  )
                "
                alt=""
                :loading="lazy"
              />
            </div>
            <div class="flex items-center gap-[2px]">
              <span class="langauge-label">
                {{ defaultLanguageForDisplay }}
              </span>
            </div>
            <svg-icon svg-name="icon-tick" class="icon-tick" />
          </div>
          <div
            v-for="(lang, index) in languages"
            :key="index"
            class="flex items-center cursor-pointer gap-2 language-option"
            @click="switchLanguage(lang.ISO)"
          >
            <div class="flex items-center">
              <div class="icon-lang"></div>
              <img
                :class="isMobile ? 'flag-img-mobile' : 'flag-img'"
                :src="
                  getAssetImage(`assets/materials/languageIcon/${lang.ISO}.svg`)
                "
                alt=""
                :loading="lazy"
              />
            </div>
            <div class="flex items-center gap-[2px]">
              <span class="langauge-label">
                {{ lang.LanguageLocalName }}
              </span>
            </div>
          </div>
        </div>
      </el-collapse-item>
    </el-collapse>
  </div>
</template>

<script setup lang="ts">
import { ref } from "vue";
import { useLanguageComponent } from "@/composables/useTheme";
const { getAssetImage } = commonHelper;
const activeNames = ref([""]);
const isMobile = !useIsDesktop();
const {
  languages,
  defaultLanguage,
  switchLanguage,
  defaultLanguageForDisplay,
} = useLanguageComponent();
const scrollToTop = () => {
  setTimeout(() => {
    const el = document.getElementsByClassName("language-option");
    const wrapper = document.getElementById('right-menu-drawer')?.getElementsByClassName('el-drawer__body')[0];
    const wrapperRect = (wrapper as HTMLElement)?.getBoundingClientRect();
    const targetRect = (el[el.length - 1] as HTMLElement)?.getBoundingClientRect();
    const scrollTop = targetRect.top - wrapperRect.top + (wrapper as HTMLElement)?.scrollTop;

    (wrapper as HTMLElement)?.scrollTo({
        top: scrollTop,
        behavior: 'smooth'
      });
  }, 290)
};
watch(activeNames, (value) => {
  if (value.toString() === "language") {
    scrollToTop();
  }
})
</script>

<style scoped>
.icon-lang, .icon-lang-mobile {
  display: flex;
  width: 48px;
  height: 48px;
  justify-content: center;
  align-items: center;
  gap: 8px;
}
.icon-lang img,
.flag-img {
  height: 24px;
  width: 24px;
  border-radius: 50%;
  object-fit: cover;
}
.icon-lang-mobile img,
.flag-img-mobile {
  height: 16px;
  width: 22px;
  border-radius: 2px;
  object-fit: cover;
}
.expand-language {
  display: flex;
  width: 100%;
  padding: 8px 24px 8px 12px;
  justify-content: space-between;
  align-items: center;
}
:deep(.el-collapse) {
  --el-collapse-border-color: transparent;
  --el-collapse-header-height: 48px;
  --el-collapse-header-bg-color: transparent;
  --el-collapse-header-text-color: var(--text5);
  --el-collapse-header-font-size: 13px;
  --el-collapse-content-bg-color: transparent;
  --el-collapse-content-font-size: 13px;
  --el-collapse-content-text-color: var(--el-text-color-primary);
}
.expand-language .langauge-label {
  color: var(--text5, #fff);
  font-family: Roboto;
  font-size: 14px;
  font-style: normal;
  font-weight: 700;
  line-height: normal;
  text-transform: capitalize;
}
.expand-language .langauge-label {
  opacity: 0.5;
}
.expand-language .language-option:hover .langauge-label,
.expand-language .active.language-option .langauge-label,
.expand-language :deep(.el-collapse-item__header:hover .langauge-label),
.expand-language :deep(.el-collapse-item__header.is-active .langauge-label) {
  opacity: 1;
}
.active.language-option .langauge-label {
  color: var(--primary);
}
.active.language-option .icon-tick {
  width: 16px;
  height: 16px;
  margin-left: auto;
  fill: var(--primary);
  margin-right: 4px;
}
:deep(.el-collapse-item__arrow) {
  display: none;
}
.expand-language :deep(.el-collapse-item__header .header-icon) {
  fill: var(--text5);
}
.expand-language :deep(.el-collapse-item__header.is-active .header-icon) {
  transform: rotate(180deg);
}
</style>
